package org.richfaces.realworld.util;

import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;

import javax.imageio.ImageIO;

public class test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String directory ="C:\\Documents and Settings\\Administrator\\Desktop\\Fun";
		writeFiles(directory, "_mini", 100, 100);
	}

	private static void writeFiles(String directory, String pattern, int width, int height) {
		File f = new File(directory);
		for(String s: f.list()){
			File temp = new File(directory +"\\"+ s);
			if(temp.isDirectory() && !(directory +"\\"+ s).endsWith("avatars")){
				writeFiles(directory +"\\"+ s,pattern, width, height);
			}
			if(s.endsWith(".jpg") && !s.endsWith("_mini.jpg")&& !s.endsWith("_medium.jpg")){
				BufferedImage bsrc =null;
				try {
					bsrc = ImageIO.read(temp);
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				BufferedImage bdest = new BufferedImage(width, height,
						BufferedImage.TYPE_INT_RGB);
				Graphics2D g = bdest.createGraphics();
				int width2 = bsrc.getWidth();
				int height2 = bsrc.getHeight();
				double d = (double) width
						/ width2;
				double e = (double) height / height2;
				AffineTransform at = AffineTransform.getScaleInstance(d, e);
				Map<RenderingHints.Key, Object> hints = new HashMap<RenderingHints.Key, Object>();
				hints.put(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
				g.addRenderingHints(hints);
				g.drawRenderedImage(bsrc, at);
				String dest = transformPath(directory +"\\"+ s, pattern);
				try {
					ImageIO.write(bdest, "JPG", new File(dest));
				} catch (IOException ex) {
					// TODO Auto-generated catch block
					ex.printStackTrace();
				}
			}
		}
	}

	private static String transformPath(String target, String substitute){
		String begin = target.substring(0, target.lastIndexOf("."));
		String end = target.substring(target.lastIndexOf("."));
		return begin + substitute + end;
	}
}
